#!/usr/bin/env python
# -*- coding: utf-8 -*-

# An ES Tools replacement on new CS:S update by fratacos
# Version 0.46

#[Added]
#ban, cvaraddflag, cvardelflag, dissolve, getip, kick, knifeonly, and playercount

#[Fixed]
#curtime, getgravity, isonly, and unregeventblock
#es_ commands to es_x

#[Known Issues]
#endround, rocket, and shake are different from EST
#death and restriction functions are fakes
#all commands are in lower cases (this is a limitation of es.regcmd)
#some player selections (ex: #ct) are not compatible with EST

#[currently not possible]
#est_effect*
#est_enable_PerUserKeyEvents

import es
import spe
import gamethread
import playerlib
import time
import vecmath
import random

timer = 0
starttime = time.time()
regclientcmd_list = []
restrict_list = {}
modplayerweapon_list = {}
modweapon_list = {}
modified_deaths = 0
deaths_list = {}
regeventblock_list = {}
allweapons = ["weapon_ak47", "weapon_aug", "weapon_awp", "weapon_c4", "weapon_deagle", "weapon_elite", "weapon_famas", "weapon_fiveseven", "weapon_flashbang", "weapon_g3sg1", "weapon_galil", "weapon_glock", "weapon_hegrenade", "weapon_knife", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_mac10", "weapon_mp5navy", "weapon_p228", "weapon_p90", "weapon_scout", "weapon_sg550", "weapon_sg552", "weapon_smokegrenade", "weapon_tmp", "weapon_ump45", "weapon_usp", "weapon_xm1014"]
allflags = ["gamedll", "protected", "sponly", "notify", "cheat", "userinfo", "unlogged", "replicated"]

def load():
	es.addons.registerClientCommandFilter(clientcommandfilter)
	es.addons.registerTickListener(ticklistener)
	spe.registerPreHook("player_hurt", pre_player_hurt)
def unload():
	spe.unregisterPreHook("player_hurt", pre_player_hurt)
	es.addons.unregisterTickListener(ticklistener)
	es.addons.unregisterClientCommandFilter(clientcommandfilter)

def adddownload(param):
	es.stringtable("downloadables", param)
def armor(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_ArmorValue", v)
def armoradd(users, value):
	armor(users, "+", value)
def ban(users, time, reason = ""):
	flag = 0
	if reason == "":
		flag = 1
	for userid in getusers(users):
		if flag:
			es.ServerCommand("banid %s %s kick" % (time, userid))
		else:
			es.ServerCommand("banid %s %s" % (time, userid))
			es.ServerCommand("kickid %s %s" % (userid, reason))
def burn(users, time = 0):
	t = int(time)
	for userid in getusers(users):
		if t != 0:
			es.fire(userid, "!self", "IgniteLifetime", t)
		else:
			es.fire(userid, "!self", "ignite")
def cash(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_iAccount", v)
def cashadd(users, value):
	cash(users, "+", value)
def cexec(users, command):
	for userid in getusers(users):
		es.ServerCommand("es_xsexec %s %s" % (userid, command))
def csay(users, text):
	es.usermsg("create", "centermsg", "TextMsg")
	es.usermsg("write", "byte", "centermsg", 4)
	es.usermsg("write", "string", "centermsg", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "centermsg", userid)
	es.usermsg("delete", "centermsg")
def curtime():
	global timer
	if timer == 0:
		timer = time.time()
		return 0
	else:
		return time.time() - timer
def cvaraddflag(cvar, gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated):
	global allflags
	data = [gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated]
	count = 0
	while count < 8:
		if int(data[count]) == 1:
			es.flags("add", allflags[count], cvar)
		count += 1
def cvardelflag(cvar, gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated):
	global allflags
	data = [gamedll, protected, sponly, notify, cheat, userinfo, unlogged, replicated]
	count = 0
	while count < 8:
		if int(data[count]) == 1:
			es.flags("remove", allflags[count], cvar)
		count += 1
def damage(source, target, value):
	flag = 0
	if str(source) == "0":
		for userid in getusers(target):
			source = userid
			es.fire(userid, "!self", "addoutput", "targetname mrdamage")
			index = es.createentity("point_hurt")
			es.entitysetvalue(index, "damage", value)
			es.entitysetvalue(index, "damagetype", 32)
			es.entitysetvalue(index, "targetname", index)
			es.fire(source, index, "addoutput", "DamageTarget mrdamage")
			es.fire(source, index, "Hurt")
			es.fire(source, index, "Kill")
			es.fire(userid, "!self", "addoutput", "targetname mrnothing")
	else:
		targets = getusers(target)
		for userid in targets:
			es.fire(userid, "!self", "addoutput", "targetname mrdamage")
		index = es.createentity("point_hurt")
		es.entitysetvalue(index, "damage", value)
		es.entitysetvalue(index, "damagetype", 32)
		es.entitysetvalue(index, "targetname", index)
		es.entitysetvalue(index, "classname", getgun(source))
		es.fire(source, index, "addoutput", "DamageTarget mrdamage")
		es.fire(source, index, "Hurt")
		es.fire(source, index, "Kill")
		for userid in targets:
			es.fire(userid, "!self", "addoutput", "targetname mrnothing")
def deafen(users, total, percent, fadeout, fadeback):
	for userid in getusers(users):
		es.fadevolume(userid, percent, fadeout, total, fadeback)
def deathadd(users, value):
	deaths(users, "+", value)
def deaths(users, param, v):
	global deaths_list
	global modified_deaths
	if not param in "=+-":
		return
	if modified_deaths == 0:
		modified_deaths = 1
		index = es.getentityindex("cs_player_manager")
		players = playerlib.getPlayerList("#all")
		for player in players:
			deaths_list[player.userid] = es.getindexprop(index, "CPlayerResource.m_iDeaths.%.3d" % player.attributes["index"])
	value = int(v)
	for userid in getusers(users):
		if param == "=":
			deaths_list[userid] = value
		if param == "+":
			deaths_list[userid] += value
		if param == "-":
			deaths_list[userid] -= value
def deathset(users, value):
	deaths(users, "=", value)
def dissolve(param):
	trigger = es.getuserid()
	index = es.createentity("env_entity_dissolver", trigger)
	es.entitysetvalue(index, "target", param)
	es.entitysetvalue(index, "magnitude", 1)
	es.entitysetvalue(index, "dissolvetype", 3)
	es.spawnentity(index)
	es.fire(trigger, "env_entity_dissolver", "Dissolve")
	es.fire(trigger, trigger, "Kill")
def deleteragdolls(users = 0):
	if str(users) == "0":
		es.fire(es.getuserid(), "cs_ragdoll", "Kill", 0.15)
		return
	handles = []
	for userid in getusers(users):
		handles.append(es.getplayerhandle(userid))
	ragdolls = es.createentitylist("cs_ragdoll")
	for index in ragdolls:
		if es.getindexprop(index, "CCSRagdoll.m_hPlayer") in handles:
			setentname(index, "theragdoll")	
	es.fire(es.getuserid(), "theragdoll", "Kill", 0.15)
def dropweapon(users, param):
	global allweapons
	for userid in getusers(users):
		name = getweaponname(userid, param)
		for item in name:
			if item in allweapons:
				spe.dropWeapon(userid, item)
def endround(time, reason):
	t = int(time)
	r = int(reason)
	if not (0 < r and r < 17):
		return
	data = [["#Target_Bombed", 2], ["#VIP_Escaped", 3], ["#VIP_Assassinated", 2], ["#Terrorists_Escaped", 2], ["#CTs_PreventEscape", 3], ["#Escaping_Terrorists_Neutralized", 3], ["#Bomb_Defused", 3], ["#CTs_Win", 3], ["#Terrorists_Win", 2], ["#Round_Draw", 0], ["#All_Hostages_Rescued", 3], ["#Target_Saved", 3], ["#Hostages_Not_Rescued", 2], ["#Terrorists_Not_Escaped", 3], ["#VIP_Not_Escaped", 2], ["#Game_Commencing", 0]]
	winner = data[r - 1][1]
	text = data[r - 1][0]
	es.event("initialize", "round_end")
	es.event("setint", "round_end", "winner", winner)
	es.event("setint", "round_end", "reason", r)
	es.event("setstring", "round_end", "message", text)
	es.event("fire", "round_end")
	gamethread.delayed(t, endround_delayed1, (t, text))
	gamethread.delayed(t + 0.20, endround_delayed2, (t, text))
def endround_delayed1(t, text):
	es.flags("remove", "cheat", "endround")
	es.ServerCommand("endround")
def endround_delayed2(t, text):
	es.flags("add", "cheat", "endround")
	if t >= 2:
		es.centermsg("")
	else:
		es.centermsg(text)
def entteleport(index, x, y, z):
	setentname(index, "theentity")
	es.fire(es.getuserid(), "theentity", "addoutput", "origin %d %d %d" % (float(x), float(y), float(z)))
def extinguish(users):
	for userid in getusers(users):
		es.fire(userid, "!self", "IgniteLifetime", 0)
def fade(users, type, fadetime, totaltime, r, g, b, a):
	t = int(type)
	if t == 1:
		type = 2
	elif t == 0:
		type = 1
	else:
		type = 8 + 16
	es.usermsg("create", "fade", "Fade")
	es.usermsg("write", "short", "fade", float(fadetime) * 1000)
	es.usermsg("write", "short", "fade", float(totaltime) * 1000)
	es.usermsg("write", "short", "fade", int(type))
	es.usermsg("write", "byte", "fade", int(r))
	es.usermsg("write", "byte", "fade", int(g))
	es.usermsg("write", "byte", "fade", int(b))
	es.usermsg("write", "byte", "fade", int(a))
	for userid in getusers(users):
		es.usermsg("send", "fade", userid)
	es.usermsg("delete", "fade")
def freeze(users, param = 1):
	# we can't bit operate directly because movetype is not proper integer
	for userid in getusers(users):
		movetype = es.getplayerprop(userid, "CBaseEntity.movetype")
		if str(param) == "1":
			if movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype - 2)
		else:
			if not movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype + 2)
def getammo(users, param):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			return player.ammo.primary
		if secondary in name:
			return player.ammo.secondary
	return None
def getarmor(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
	return None
def getclipammo(users, param):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			return player.clip.primary
		if secondary in name:
			return player.clip.secondary
	return None
def getdeaths(users):
	global deaths_list
	global modified_deaths
	if modified_deaths != 0:
		for userid in getusers(users):
			return deaths_list[userid]
	else:
		index = es.getentityindex("cs_player_manager")
		for userid in getusers(users):
			return es.getindexprop(index, "CPlayerResource.m_iDeaths.%.3d" % playerlib.getPlayer(userid).attributes["index"])
	return None
def getfb(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getFB()
	return None
def getgravity(users):
	for userid in getusers(users):
		index = playerlib.getPlayer(userid).attributes["index"]
		return es.entitygetvalue(index, "gravity")
	return None
def getgun(users):
	for userid in getusers(users):
		name = playerlib.getPlayer(userid).weapon
		if name != None:
			return name
	return "weapon_none"
def gethe(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getHE()
	return None
def gethealth(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CBasePlayer.m_iHealth")
	return None
def getindex(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).attributes["index"]
	return None
def getip(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).address
def getkills(users):
	index = es.getentityindex("cs_player_manager")
	for userid in getusers(users):
		return es.getindexprop(index, "CPlayerResource.m_iScore.%.3d" % playerlib.getPlayer(userid).attributes["index"])
	return None
def getname(users):
	for userid in getusers(users):
		return es.getplayername(userid)
	return None
def getprimary(users):
	for userid in getusers(users):
		name = playerlib.getPlayer(userid).getPrimary()
		if name != 0:
			return name
	return "weapon_none"
def getsecondary(users):
	for userid in getusers(users):
		name = playerlib.getPlayer(userid).getSecondary()
		if name != 0:
			return name
	return "weapon_none"
def getsg(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getSG()
def getslot(users, param):
	if not str(param) in "1234":
		return
	for userid in getusers(users):
		weapons = getweaponname(userid, param)
		if weapons == [ "weapon_none" ]:
			continue
		if len(weapons) > 0:
			return weapons[0]
	return "weapon_none"
def getsteam(users):
	for userid in getusers(users):
		return es.getplayersteamid(userid)
	return None
def getteam(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	return None
def getuserid(users):
	for userid in getusers(users):
		return userid
	return None
def getweaponindex(users, param):
	handles = []
	for userid in getusers(users):
		handles.append(es.getplayerhandle(userid))
	name = getweaponname(userid, param)
	if name == ["weapon_none"]:
		return 0
	for item in name:
		weapon = es.createentitylist(item)
		for index in weapon:
			if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") in handles:
				return index
	return 0
def give(users, param):
	for userid in getusers(users):
		es.ServerCommand("es_xgive %s %s" % (userid, param))
def god(users, param = 1):
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if not dead:
			if str(param) == "1":
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 0)
			else:
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
def hasdefuser(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).hasDefuser()
	return 0
def hashelmet(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).hasHelmet()
	return 0
def haskevlar(users):
	for userid in getusers(users):
		if es.getplayerprop(userid, "CCSPlayer.m_ArmorValue") > 0:
			return 1
		else:
			return 0
	return 0
def health(users, param, value = 0):
	v = int(value)
	if v == 0:
		v = int(param)
		param = "="
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CBasePlayer.m_iHealth", v)
def healthadd(users, value):
	health(users, "+", value)
def hsay(users, text):
	es.usermsg("create", "hudhint", "HintText")
	es.usermsg("write", "string", "hudhint", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "hudhint", userid)
	es.usermsg("delete", "hudhint")
def isalive(users):
	for userid in getusers(users):
		if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
			return 0
		else:
			return 1
def isalpha(param):
	if param.isalpha():
		return 1
	else:
		return 0
def isbomber(users):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		if player.hasC4():
			return 1
		else:
			return 0
def isnumeric(param):
	if param.startswith("-"):
		param = param[1:]
	param = param.replace(".", "")
	if param.isdigit():
		return 1
	else:
		return 0
def isonly(param, checker):
	for item in param:
		if not item in checker:
			return 0
	return 1
def jetpack(users, param):
	p = int(param)
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.jetpack(p)
def kick(users, reason = ""):
	flag = 0
	if reason == "":
		flag = 1
	for userid in getusers(users):
		if flag:
			es.ServerCommand("kickid %s" % userid)
		else:
			es.ServerCommand("kickid %s %s" % (userid, reason))
def killadd(users, v):
	kills(users, "+", v)
def kills(users, param, v):
	value = int(v)
	trigger = es.getuserid()
	index = es.createentity("game_score")
	es.setentityname(index, "thescore")
	es.fire(trigger, "thescore", "addoutput", "spawnflags 1")
	if param == "+":
		apply = value
	if param == "-":
		apply = -value
	for userid in getusers(users):
		if param == "=":
			apply = value - getkills(userid)
		es.fire(userid, "thescore", "addoutput", "points %d" % apply)
		es.fire(userid, "thescore", "ApplyScore")
	es.fire(trigger, "thescore", "Kill")
def killset(users, v):
	kills(users, "=", v)
def knifeonly(users):
	for userid in getusers(users):
		if getweaponname(userid, 1) == ["weapon_none"] and getweaponname(userid, 2) == ["weapon_none"] and getweaponname(userid, 3) == ["weapon_knife"] and getweaponname(userid, 4) == ["weapon_none"]:
			return 1
		else:
			return 0
def loop(variable, users, command):
	for userid in getusers(users):
		es.ServerCommand("%s %s" % (variable, userid))
		es.ServerCommand(command)
def modplayerweapon(users, param, value):
	global allweapons
	global modplayerweapon_list
	v = int(value)
	if not param in allweapons:
		return
	for userid in getusers(users):
		id = int(userid)
		if v == -1:
			mods = modplayerweapon_list[id]
			for item in mods:
				if item[0] == param:
					modplayerweapon_list[id].remove(item)
					break
		else:
			if not id in modplayerweapon_list:
				modplayerweapon_list[id] = []
			modplayerweapon_list[id].append([param, v])
def modweapon(param, value):
	global allweapons
	if not param in allweapons:
		return
	global modweapon_list
	v = int(value)
	if v == -1:
		del modweapon_list[param]
	else:
		modweapon_list[param] = v
def motd(users, title, type, msg):
	data = { "title":title, "type":type, "msg":msg }
	es.usermsg('create', 'panel', 'VGUIMenu')
	es.usermsg('write', 'string', 'panel', "info")
	es.usermsg('write', 'byte', 'panel', 1)
	es.usermsg('write', 'byte', 'panel', len(data))
	for item in data:
		es.usermsg('write', 'string', 'panel', item)
		es.usermsg('write', 'string', 'panel', data[item])
	for userid in getusers(users):
		es.usermsg('send', 'panel', userid)
	es.usermsg('delete', 'panel')
def motd_f(users, title, command, path):
	motd(users, unicode(title), "3", path)
def motd_t(users, title, command, text):
	motd(users, unicode(title), "0", unicode(text))
def motd_w(users, title, command, url):
	motd(users, unicode(title), "2", url)
def msg(users, value):
	for userid in getusers(users):
		es.tell(userid, "#multi", value)
def name(users, value):
	for userid in getusers(users):
		if es.getplayersteamid(userid) == "BOT":
			es.botsetvalue(userid, "name", value)
		else:
			es.cexec(userid, "name %s" % value)
def noclip(users, value):
	if int(value) == 1:
		v = 1
	else:
		v = 0
	for userid in getusers(users):
		playerlib.getPlayer(userid).noclip(v)
def physpush(users, x, y, z):
	xx = float(x)
	yy = float(y)
	zz = float(z)
	if xx == 0 and yy == 0 and zz == 0:
		for userid in getusers(users):
			xx = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[0]")
			yy = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[1]")
			zz = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[2]")
			es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (-xx, -yy, -zz))
		return
	for userid in getusers(users):
		vec = vecmath.vector(es.getplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity"))
		es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (xx + vec[0], yy + vec[1], zz + vec[2]))
def play(users, param, duration = 0, volume = 1.0):
	d = float(duration)
	v = float(volume)
	for userid in getusers(users):
		es.playsound(userid, param, v)
	if d != 0:
		gamethread.delayed(d, stopsound, (userid, param))
def playedict(index, param, volume = 1.0, attenuation = 0.5):
	v = float(volume)
	a = float(attenuation)
	es.emitsound("entity", int(index), param, v, a)
def playercount(users):
	return len(getusers(users))
def playplayer(users, param, volume = 1.0, attenuation = 0.5):
	v = float(volume)
	a = float(attenuation)
	for userid in getusers(users):
		es.emitsound("player", userid, param, v, a)
def randplayer(users):
	players = getusers(users)
	max = len(players)
	if max > 0:
		no = random.randint(0, max - 1)
		count = 0
		for item in players:
			if count == no:
				return item
			count += 1
	return None
def regclientcmd(command, type):
	global regclientcmd_list
	if str(type) == "1":
		t = 1
	else:
		t = 0
	for item in regclientcmd_list:
		if item[0] == command:
			regclientcmd_list.remove(item)
			break
	regclientcmd_list.append([command, t])
def regeventblock(eventname, code):
	global regeventblock_list
	regeventblock_list[eventname] = code
	spe.registerPreHook(eventname, hooked)
def remove(param):
	es.fire(es.getuserid(), str(param), "Kill")
def removeidle(param):
	if param == "weapon":
		global allweapons
		for weapon in allweapons:
			removeidle(weapon)
		return
	weapon = es.createentitylist(param)
	for index in weapon:
		if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == -1:
			setentname(index, "theweapon")
	es.fire(es.getuserid(), "theweapon", "Kill")
def removeweapon(users, param):
	handles = {}
	flag = 0
	weapons = []
	if str(param) in "1234":
		flag = 1
	else:
		weapons = [param]
	for userid in getusers(users):
		handle = es.getplayerhandle(userid)
		if flag:
			name = getweaponname(userid, param)
			if name == ["weapon_none"]:
				continue
			for item in name:
				weapons.append(item)
				if item in handles:
					handles[item].append(handle)
				else:
					handles[item] = [handle]
		else:
			if param in handles:
				handles[param].append(handle)
			else:
				handles[param] = [handle]
	for weaponname in weapons:
		weapon = es.createentitylist(weaponname)
		for index in weapon:
			if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") in handles[weaponname]:
				setentname(index, "theweapon")
	es.fire(es.getuserid(), "theweapon", "Kill")
def restrict(users, param):
	if str(param) in "1234":
		return
	if str(param) == "mp5":
		param = "mp5navy"
	item = "weapon_%s" % param
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	for userid in getusers(users):
		if not item in restrict_list[userid]:
			restrict_list[userid].append(item)
def restrictall(users):
	global restrict_list
	global allweapons
	for userid in getusers(users):
		restrict_list[userid] = allweapons
def rocket(users):
	# smoke sprites -> explosion white ring -> bones (optional)
	god(users, 0)
	shake(users, 10, 40, 25)
	for userid in getusers(users):
		es.emitsound("player", userid, "weapons/rpg/rocketfire1.wav", 0.5, 0.5)
		gamethread.delayed(1, es.emitsound, ("player", userid, "weapons/rpg/rocket1.wav", 0.5, 0.5))
		vec = vecmath.vector(es.getplayerprop(userid, "CBaseEntity.m_vecOrigin"))
		gamethread.delayed(1, rocket_loop, (userid, 0, vec[2], vec[2]))
def rocket_loop(userid, count, height, oldheight):
	physpush(userid, 0, 0, 250)
	origin = es.getplayerprop(userid, "CBaseEntity.m_vecOrigin")
	vec = vecmath.vector(origin)
	if vec[2] >= height or count < 10:
		gamethread.delayed(0.2, rocket_loop, (userid, count + 1, vec[2], height))
	else:
		es.stopsound(userid, "weapons/rpg/rocket1.wav")
		es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", 0.5, 0.5)
		index = es.createentity("env_explosion")
		es.spawnentity(index)
		es.setentityname(index, "theexplosion")
		vec = vecmath.vector(es.getplayerprop(userid, "CBaseEntity.m_vecOrigin"))
		vec[2] += 50
		es.fire(userid, "theexplosion", "addoutput", "origin %f %f %f" % (vec[0], vec[1], vec[2]))
		es.fire(userid, "theexplosion", "addoutput", "iRadiusOverride 100")
		es.fire(userid, "theexplosion", "addoutput", "iMagnitude 100")
		es.fire(userid, "theexplosion", "Explode")
		es.fire(userid, "theexplosion", "Kill")
		slay(userid)
def setammo(users, param, value):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			player.setPrimaryAmmo(int(value))
		if secondary in name:
			player.setSecondaryAmmo(int(value))
def setarmor(users, value):
	armor(users, "=", value)
def setcash(users, value):
	cash(users, "=", value)
def setclipammo(users, param, value):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			player.setPrimaryClip(int(value))
		if secondary in name:
			player.setSecondaryClip(int(value))
def setentname(index, param):
	es.setentityname(index, param)
def setgravity(users, ratio):
	for userid in getusers(users):
		es.fire(userid, "!self", "addoutput", "gravity %f" % float(ratio))
def sethealth(users, value):
	health(users, "=", value)
def setmodel(users, model):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setModel(model)
def setplayercolor(users, r, g, b, a, weapon):
	w = int(weapon)
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setColor(int(r), int(g), int(b), int(a))
		if w == 1:
			player.setWeaponColor(int(r), int(g), int(b), int(a))
def shake(users, time, distance, value):
	es.usermsg("create", "shake", "Shake")
	es.usermsg("write", "byte", "shake", 0)
	es.usermsg("write", "float", "shake", float(value))
	es.usermsg("write", "float", "shake", float(distance))
	es.usermsg("write", "float", "shake", float(time))
	for userid in getusers(users):
		es.usermsg("send", "shake", userid)
	es.usermsg("delete", "shake")
def slay(users):
	damage(0, users, 10000)
def spawn(users, param = 0):
	gamethread.delayed(0.15, spawn_delayed, (users, param))
def spawn_delayed(users, param):
	global spawn_restrict
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		es.ServerCommand("es_xsetplayerprop %s CBasePlayer.m_lifeState 512" % userid)
		es.ServerCommand("es_xsetplayerprop %s CCSPlayer.m_iPlayerState 0" % userid)
		es.ServerCommand("es_xspawnplayer %s" % userid)
def speed(users, value):
	for userid in getusers(users):
		es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", value)
def stopsound(users, param):
	for userid in getusers(users):
		es.stopsound(userid, param)
def stripplayer(users, param = 0):
	trigger = es.getuserid()
	index = es.createentity("player_weaponstrip")
	es.setentityname(index, "thestrip")
	for userid in getusers(users):
		if str(param) != "0":
			es.fire(userid, "thestrip", "StripWeaponsAndSuit")
		else:
			es.fire(userid, "thestrip", "Strip")
	es.fire(trigger, "thestrip", "Kill")
def strlen(param):
	return len(param)
def strtolower(param):
	return param.lower()
def strtoupper(param):
	return param.upper()
def team(users, no):
	if not str(no) in "0123":
		return
	n = int(no)
	for userid in getusers(users):
		if n > 1:
			spe.switchTeam(userid, n)
		else:
			index = playerlib.getPlayer(userid).attributes["index"]
			setentname(index, "thetarget")
	if n <= 1:
		es.ServerCommand("es_xfire %s thetarget SetTeam %s" % (es.getuserid(), no))
def teleport(users, x, y, z):
	for userid in getusers(users):
		es.setpos(userid, float(x), float(y), float(z))
def unregclientcmd(command):
	global regclientcmd_list
	if [command, 0] in regclientcmd_list:
		regclientcmd_list.remove([command, 0])
	if [command, 1] in regclientcmd_list:
		regclientcmd_list.remove([command, 1])
def unregeventblock(eventname, code = ""):
	global regeventblock_list
	del regeventblock_list[eventname]
	spe.unregisterPreHook(eventname, hooked)
def unrestrict(users, param):
	if str(param) in "1234":
		return
	if str(param) == "mp5":
		param = "mp5navy"
	item = "weapon_%s" % param
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	for userid in getusers(users):
		if item in restrict_list[userid]:
			restrict_list[userid].remove(item)
def unrestrictall(users):
	global restrict_list
	for userid in getusers(users):
		restrict_list[userid] = []
def uptime():
	global starttime
	return time.time() - starttime

def es_player_chat(event_var):
	userid = event_var["userid"]
	if int(userid) <= 0:
		return
	team = es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	flag = 0
	if team in [0, 1]:
		if not int(event_var["teamonly"]):
			players = playerlib.getUseridList("#alive")
			type = "#Cstrike_Chat_AllSpec"
			flag = 1
	elif es.getplayerprop(userid, "CBasePlayer.pl.deadflag") == 1:
		flag = 1
		if int(event_var["teamonly"]):
			if team == 2:
				str = "#t,#alive"
				type = "#Cstrike_Chat_T_Dead"
			if team == 3:
				str = "#ct,#alive"
				type = "#Cstrike_Chat_CT_Dead"
			players = playerlib.getUseridList(str)
		else:
			players = playerlib.getUseridList("#alive")
			type = "#Cstrike_Chat_AllDead"
	if flag == 1:
		name = es.getplayername(userid)
		text = event_var["text"]
		es.usermsg('create', 'deadchat', 'SayText2')
		es.usermsg('write', 'byte', 'deadchat', event_var["es_userindex"])
		es.usermsg('write', 'byte', 'deadchat', 1)
		es.usermsg('write', 'string', 'deadchat', type)
		es.usermsg('write', 'string', 'deadchat', unicode(name))
		es.usermsg('write', 'string', 'deadchat', unicode(text))
		for userid in players:
			es.usermsg('send', 'deadchat', userid)
		es.usermsg('delete', 'deadchat')

def player_connect(event_var):
	global restrict_list
	global deaths_list
	userid = int(event_var["userid"])
	restrict_list[userid] = []
	deaths_list[userid] = 0

def player_disconnect(event_var):
	global restrict_list
	global deaths_list
	userid = int(event_var["userid"])
	del restrict_list[userid]
	del deaths_list[userid]

def pre_player_hurt(event_var):
	if es.ServerVar("est_enable_weapon_mods") == 0:
		return
	userid = int(event_var["userid"])
	attacker = int(event_var["attacker"])
	if attacker == 0 or userid == 0:
		return
	item = "weapon_%s" % event_var["weapon"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global modplayerweapon_list
	global modweapon_list
	flag = 0
	if attacker in modplayerweapon_list:
		mods = modplayerweapon_list[attacker]
		for mod in mods:
			if mod[0] == item:
				point = mod[1]
				flag = 1
				break
	elif item in modweapon_list:
		point = modweapon_list[item]
		flag = 1
	if flag == 0:
		return
	health = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
	if event_var["dmg_health"] != point:
		es.setplayerprop(userid, "CBasePlayer.m_iHealth", health + event_var["dmg_health"])
		damage(attacker, userid, point)

def player_death(event_var):
	global deaths_list
	userid = int(event_var["userid"])
	deaths_list[userid] += 1

def item_pickup(event_var):
	# we have to think about autobuy and rebuy
	weapon_restrictions = es.ServerVar("est_enable_weapon_restrictions")
	if not weapon_restrictions:
		return
	userid = int(event_var["userid"])
	item = "weapon_%s" % event_var["item"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	restricts = restrict_list[userid]
	if item in restricts:
		removeweapon(userid, item)

def es_map_start(event_var):
	global modified_deaths
	modified_deaths = 0

def round_start(event_var):
	global timer
	timer = time.time()

def hooked(event_var):
	eventname = event_var["spe_eventname"]
	global regeventblock_list
	es.ServerCommand(regeventblock_list[eventname])

def clientcommandfilter(userid, args):
	global regclientcmd_list
	global restrict_list
	advanceddrop = es.ServerVar("est_allowadvanceddrop")
	weapon_restrictions = es.ServerVar("est_enable_weapon_restrictions")
	cmd = args[0].lower()
	flag = 0
	if weapon_restrictions:
		if advanceddrop and cmd == "drop" and not "drop" in regclientcmd_list:
			flag = 1
	else:
		if advanceddrop and cmd == "drop":
			flag = 1
	if flag == 1:
		gun = getgun(userid)
		if gun in ["weapon_knife", "weapon_hegrenade", "weapon_flashbang", "weapon_smokegrenade"]:
			spe.dropWeapon(userid, gun)
			return False
	if cmd == "buy" and es.getplayerprop(userid, "CCSPlayer.m_bInBuyZone") and len(args) > 1 and weapon_restrictions:
		restricts = restrict_list[userid]
		item = "weapon_%s" % args[1].lower()
		if item == "weapon_mp5":
			item = "weapon_mp5navy"
		if item in restricts:
			es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
			return False
	for item in regclientcmd_list:
		if item[0] == cmd:
			es.event("initialize", "est_cmdhook")
			es.event("setint", "est_cmdhook", "userid", userid)
			es.event("setstring", "est_cmdhook", "hooktext", args[0])
			es.event("setstring", "est_cmdhook", "commandstring", str(args[1:]))
			es.event("fire", "est_cmdhook")
			if int(item[1]) != 0: return True
			else: return False
	return True

def getweaponname(userid, param):
	if str(param) in "1234":
		p = int(param)
		player = playerlib.getPlayer(userid)
		gun = False
		if p == 1:
			gun = player.getPrimary()
		if p == 2:
			gun = player.getSecondary()
		if gun != False:
			return [gun]
		if p == 3:
			return ["weapon_knife"]
		if p == 4:
			name = []
			if player.getHE() > 0:
				name.append("weapon_hegrenade")
			if player.getSG() > 0:
				name.append("weapon_smokegrenade")
			if player.getFB() > 0:
				name.append("weapon_flashbang")
			if name != []:
				return name
	else:
		if param.startswith("weapon_"):
			return [param]
		else:
			if param == "mp5":
				param = "mp5navy"
			if param != "":
				return ["weapon_%s" % param]
	return ["weapon_none"]

def getusers(users):
	#TODO: http://www.eventscripts.com/pages/Est_PlayerSelection
	# Python style #alive, #all, #bot, #ct, #dead, #human, #spec, #t, #un
	# ex: #alive,#ct (for CT who is alive)
	# EST style #a, #c, #3, #t, #2, #s, #1, #u, #0, #h, #b, #l, #d
	# ex: #23!d (for all T and CT who is alive)
	# issue 1: #ct (use #tc or #23 instead for EST style)
	# issue 2: names start with # are not supported
	pyfilter = ["#alive", "#all", "#bot", "#ct", "#dead", "#human", "#spec", "#t", "#un"]
	if str(users)[0] == "#":
		status = 0
		notfilter = ""
		if "," in users:
			status = 1
		if "!" in users:
			all = users.split("!")
			users = all[0]
			notfilter = all[1]
			status = 2
		if status == 0:
			if users in pyfilter:
				status = 1
			else:
				status = 2
		if status == 2:
			est = [["t","#t"], ["c","#ct"], ["3","#ct"], ["2","#t"], ["s","#spec"], ["1","#spec"], ["u","#un"], ["h","#human"], ["b","#bot"], ["l","#alive"], ["a","#all"], ["d","#dead"] ]
			filter = []
			for item in est:
				if item[0] in users:
					idlist = playerlib.getUseridList(item[1])
					filter.extend(idlist)
			users = set(filter)
			if notfilter != "":
				filter = []
				for item in est:
					if item[0] in notfilter:
						idlist = playerlib.getUseridList(item[1])
						filter.extend(idlist)
				notfilter = set(filter)
				for item in notfilter:
					if int(item) in users:
						users.remove(int(item))
		else:
			users = playerlib.getUseridList(users)
	else:
		newusers = []
		all = playerlib.getUseridList("#all")
		for userid in all:
			if users == es.getplayersteamid(userid):
				newusers.append(userid)
			elif str(users) in es.getplayername(userid):
				newusers.append(userid)
		if newusers == []:
			test = str(users)
			if not "," in test:
				if test.isdigit():
					testid = int(test)
					if testid in all:
						return [testid]
				return []
		else:
			users = newusers
	if not hasattr(users, "__iter__"):
		users = (users,)
	return users

def unicode(text):
	# for unicode texts in usermsg
	status = 0
	error = ":; "
	for item in error:
		if item in text:
			status = 1
			break
	if status:
		msg = text
	else:
		msg = '"' + text + '"'
	return msg

def ticklistener():
	global modified_deaths
	if modified_deaths != 0:
		index = es.getentityindex("cs_player_manager")
		global deaths_list
		players = playerlib.getPlayerList("#all")
		for player in players:
			es.setindexprop(index, "CPlayerResource.m_iDeaths.%.3d" % player.attributes["index"], deaths_list[int(player.userid)])